﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace WcfStreamClient.WcfStreamReference {
    
    
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
    [System.ServiceModel.ServiceContractAttribute(ConfigurationName="WcfStreamReference.IWcfStream")]
    public interface IWcfStream {
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IWcfStream/GetStream", ReplyAction="http://tempuri.org/IWcfStream/GetStreamResponse")]
        System.IO.Stream GetStream(string _name);
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IWcfStream/GetStream", ReplyAction="http://tempuri.org/IWcfStream/GetStreamResponse")]
        System.Threading.Tasks.Task<System.IO.Stream> GetStreamAsync(string _name);
        
        // CODEGEN: Generating message contract since the wrapper name (RequestFileMessage) of message RequestFileMessage does not match the default value (GetMStream)
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IWcfStream/GetMStream", ReplyAction="http://tempuri.org/IWcfStream/GetMStreamResponse")]
        ResponseFileMessage GetMStream(RequestFileMessage request);
        
        [System.ServiceModel.OperationContractAttribute(Action="http://tempuri.org/IWcfStream/GetMStream", ReplyAction="http://tempuri.org/IWcfStream/GetMStreamResponse")]
        System.Threading.Tasks.Task<ResponseFileMessage> GetMStreamAsync(RequestFileMessage request);
    }
    
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
    [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
    [System.ServiceModel.MessageContractAttribute(WrapperName="RequestFileMessage", WrapperNamespace="http://tempuri.org/", IsWrapped=true)]
    public partial class RequestFileMessage {
        
        [System.ServiceModel.MessageBodyMemberAttribute(Namespace="http://tempuri.org/", Order=0)]
        public string Name;
        
        public RequestFileMessage() {
        }
        
        public RequestFileMessage(string Name) {
            this.Name = Name;
        }
    }
    
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
    [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
    [System.ServiceModel.MessageContractAttribute(WrapperName="ResponseFileMessage", WrapperNamespace="http://tempuri.org/", IsWrapped=true)]
    public partial class ResponseFileMessage {
        
        [System.ServiceModel.MessageHeaderAttribute(Namespace="http://tempuri.org/")]
        public string Name;
        
        [System.ServiceModel.MessageHeaderAttribute(Namespace="http://tempuri.org/")]
        public long Size;
        
        [System.ServiceModel.MessageBodyMemberAttribute(Namespace="http://tempuri.org/", Order=0)]
        public System.IO.Stream Stream;
        
        public ResponseFileMessage() {
        }
        
        public ResponseFileMessage(string Name, long Size, System.IO.Stream Stream) {
            this.Name = Name;
            this.Size = Size;
            this.Stream = Stream;
        }
    }
    
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
    public interface IWcfStreamChannel : IWcfStream, System.ServiceModel.IClientChannel {
    }
    
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "4.0.0.0")]
    public partial class WcfStreamClient : System.ServiceModel.ClientBase<IWcfStream>, IWcfStream {
        
        public WcfStreamClient() {
        }
        
        public WcfStreamClient(string endpointConfigurationName) : 
                base(endpointConfigurationName) {
        }
        
        public WcfStreamClient(string endpointConfigurationName, string remoteAddress) : 
                base(endpointConfigurationName, remoteAddress) {
        }
        
        public WcfStreamClient(string endpointConfigurationName, System.ServiceModel.EndpointAddress remoteAddress) : 
                base(endpointConfigurationName, remoteAddress) {
        }
        
        public WcfStreamClient(System.ServiceModel.Channels.Binding binding, System.ServiceModel.EndpointAddress remoteAddress) : 
                base(binding, remoteAddress) {
        }
        
        public System.IO.Stream GetStream(string _name) {
            return base.Channel.GetStream(_name);
        }
        
        public System.Threading.Tasks.Task<System.IO.Stream> GetStreamAsync(string _name) {
            return base.Channel.GetStreamAsync(_name);
        }
        
        [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
        ResponseFileMessage IWcfStream.GetMStream(RequestFileMessage request) {
            return base.Channel.GetMStream(request);
        }
        
        public long GetMStream(ref string Name, out System.IO.Stream Stream) {
            RequestFileMessage inValue = new RequestFileMessage();
            inValue.Name = Name;
            ResponseFileMessage retVal = ((IWcfStream)(this)).GetMStream(inValue);
            Name = retVal.Name;
            Stream = retVal.Stream;
            return retVal.Size;
        }
        
        [System.ComponentModel.EditorBrowsableAttribute(System.ComponentModel.EditorBrowsableState.Advanced)]
        System.Threading.Tasks.Task<ResponseFileMessage> IWcfStream.GetMStreamAsync(RequestFileMessage request) {
            return base.Channel.GetMStreamAsync(request);
        }
        
        public System.Threading.Tasks.Task<ResponseFileMessage> GetMStreamAsync(string Name) {
            RequestFileMessage inValue = new RequestFileMessage();
            inValue.Name = Name;
            return ((IWcfStream)(this)).GetMStreamAsync(inValue);
        }
    }
}
